function [vout] = elim_subs_bin(vin)
%
% Funci que mira si cada subsistema de vin t les relacions binries
% els altres subsistemes
%
% Autor: Josep Maria Mirats i Tur
% Data: 10-VI-1999, Barcelona
%
% Parmetres:
%
%       Entrades: vin, vector amb subsistemes
%
%       Sortida: vout, composite structure de sortida
%
% Us de la funci:
%
%               [vout] = elim_subs_bin(vin)
%
%
vout = [];
index = [0 find(vin==0) size(vin,2)+1];
nsub = size(index,2)-1;
%
for i=1:nsub,
 aux1 = vin(index(i)+1:index(i+1)-1);
 aux2 = [];
 for j=1:nsub,
  if (j ~= i)
   aux2 = [aux2 0 vin(index(j)+1:index(j+1)-1)];
  end
 end
 aux2 = aux2(2:size(aux2,2));
 bin1 = binary(aux1);
 bin2 = binary(aux2);
 [dif,b] = size(bin1);
 cont = dif;aux = dif;
 k = 1;l = 1;
 while (cont > 0 & k<=dif & l<=size(bin2,1))
  while (cont > 0 & k<=dif)
   l = 1;
   while (cont == aux & l<=size(bin2,1))
    if ( (bin1(k,1) == bin2(l,1)) & (bin1(k,2) == bin2(l,2)) )
     cont = cont-1;
    end
    l = l+1;
   end
   aux = cont;
   k = k+1;
  end 
 end
 if (cont > 0)
  vout = [vout aux1 0];
 end
end
vout = vout(1:size(vout,2)-1);
%
