function [csout] = faggregate(beh,prob,qmin,fid)
%
% Implementa algorisme de AGGREGATE
%
% Parametres d'entrada:
%
%       beh - Matriu behavior del sistema
%       prob - Vector de probabilitat del sistema
%       qmin - Qualitat minima requerida en la reconstruccio
%       fid - Indica si volem fitxer amb resultats intermitjos
%
% Inicialitza variables
%
[mb,nb] = size(beh);
%
% Troba les relacions binaries del sistema
%
bin = binary(1:nb);
%
% Troba l'error de la "totally unconnected structure"
% i escriu capalera al fitxer
%
cst = zeros(1,(nb*2)-1);
index = 1:2:(nb*2)-1;
for i=1:nb,
 cst(index(i)) = i;
end;
errunc = fstructure(beh,prob,cst);
if fid ~= 0
  wriline(fid,0,cst,(2*nb)-1);
  wriheader(fid,0,cst,(2*nb)-1);
end;
[nbin,b] = size(bin);
qual = zeros(nbin,1);
%
% Bucle que afegeix una relacio binaria i comproba quin es l'error
% de reconstruccio amb aquesta relacio binaria
%
binaux2 = zeros(0,0);	% per guardar relacions binaries fetes en un nivell
relbin = nbin;
while ( relbin > 0 )
  for i=1:relbin,
    binaux = [binaux2;bin(i,:)];
    clear cst;
    cst = compose(binaux);
    aux = max(cst);		% Proteccio necessaria per a que no
    if aux ~= nb		% falli la funcio structure en cas
      for j=1:nb-aux,		% de que en les relacions binaries
        cst = [cst,0,aux+j];	% de binaux no estiguin els nombres
      end;			% representant a totes les variables
    end;
    errst = fstructure(beh,prob,cst);
    [a,b] = size(cst);
    qual(i) = 1-(errst/errunc);
    if fid ~= 0 wriline(fid,qual(i),cst,b); end;
  end;
%
% Escull quina es la relacio binaria que mes qualitat dona al
% afegir-la. Si aquesta qualitat es < qmin seguim si no sortim
%
  [qmax,k] = max(qual);
  if qmax >= qmin break; end;
  binaux2 = [binaux2;bin(k,:)];
  bin = [bin(1:k-1,:);bin(k+1:relbin,:)];  
  relbin = relbin-1;
  if fid ~= 0
    clear cst;
    cst = compose(binaux2);
    aux = max(cst);		% Proteccio necessaria per a que no
    if aux ~= nb		% falli la funcio structure en cas
      for j=1:nb-aux,		% de que en les relacions binaries
        cst = [cst,0,aux+j];	% de binaux no estiguin els nombres
      end;			% representant a totes les variables
    end;
    [a,b] = size(cst);
    wriheader(fid,qual(k),cst,b);
  end;
  for i=1:nbin,
    qual(i) = 0;
  end;
end;
%
% Escriu les ultimes linies al fitxer
%
binaux2 = [binaux2;bin(k,:)];
csout = compose(binaux2);
aux = max(csout);		% Proteccio necessaria per a que no
if aux ~= nb			% falli la funcio structure en cas
  for j=1:nb-aux,		% de que en les relacions binaries
    csout = [csout,0,aux+j];	% de binaux no estiguin els nombres
  end;			% representant a totes les variables
end;
if fid ~= 0
  fprintf(fid,'\nMILLOR ESTRUCTURA DEL NIVELL TE QUALITAT: %6.4f\n',qual(k));
  fprintf(fid,'CONSIDERADA SUFICIENT. ACABA LA CERCA\n\n');
  fprintf(fid,'ESTRUCTURA RESULTANT: ('); 
  [a,b]=size(csout);
  cs2 = [csout,0];
  for i=1:b,
    if cs2(i) ~= 0 fprintf(fid,'%d',cs2(i)); end;
    if ( cs2(i+1) ~= 0 & cs2(i) ~= 0 ) fprintf(fid,','); end;
    if cs2(i) == 0 fprintf(fid,') ('); end;
  end;
  fprintf(fid,')\n');
end;
return
