function [bout,pout] = fextract(b1,p1,stri)
%
% Funci que extreu la matriu de comportament d'un subsistema
%
% Autor: Josep Maria Mirats i Tur
% Data: 4-II-1999, Barcelona
%
% Parmetres:
%
%       Entrada: b1, behavior del sistema
%                p1, vector de confiances del sistema
%		 stri, vector que cont el subsistema a extreure
%
%       Sortida: bout, behavior del subsistema 
%                pout, vector de confiances del sistema recombinat
%
%       Us de la funci:
%
%                       [bout,pout] = fextract(b1,p1,stri)
%
%
bout=[];
pout=p1;
%
% Comprova que el subsistema i la behavior d'entrada sn compatibles
%
[a,b] = size(b1);
c = max(stri);
if ( c > b )
 fprintf('\n FEXTRACT. Subsistema i behavior no compatibles \n\n')
 return
end
%
% Comprova que la behavior i el vector de prob. d'entrada sn compatibles
%
c = size(p1,1);
if ( a ~= c )
 fprintf('\n FEXTRACT. Behavior vector de probabilitats no compatibles \n\n')
 return
end
%
%
stri = sort(stri);
%
% Extreu el subsistema
%
a = size(stri,2);
for i = 1:a,
 bout(:,i) = b1(:,stri(i));
end
% 
% Ordena la matriu de comportament extreta i el seu vector de probabilitats
%
aux = [bout pout];
aux = sortrows(aux,[1:a]);
bout = aux(:,1:a);
pout = aux(:,a+1);
%
% Elimina files i agafa el mxim de les confiances entre estats repetits
%
[n,k] = size(bout);
%
aux = [];
paux = zeros(n,1);
aux(1,:) = bout(1,1:k);
paux(1) = pout(1);
j = 1;
for i = 2:n,
 if ( bout(i,1:k) == bout(i-1,1:k) )
  paux(j) = max([paux(j) pout(i)]);
 else
  j = j+1;
  aux = [aux; bout(i,1:k)];
  paux(j) = pout(i);
 end
end
%
bout = aux;
pout = paux(1:j);
%
