function [csout]=foptstruc(beh,prob,emax,alg,fi)
%
% Funcio que determina la descomposicio en subsistemes d'una
% estructura
%
% Josep Maria Mirats 8-IX-98
%
% Parametres d'entrada:
%
%	beh - Matriu behavior del sistema
%	prob - Vector de confiana del sistema
%	emax - error maxim permes o qualitat minima permesa
%	alg - tipus d'algorisme a seguir
%	fi - Indica si volem fitxer amb resultats intermitjos
%
%	alg = 1 - algorisme de REFINEMENT
%		Cada cop s'elimina una relacio binaria del sistema
%		A cada nivell s'elimina la relacio que menys perdua
%		de qualitat suposa en la reconstruccio del sist.
%
%	alg = 2 - algorisme d'AGGREGATE
%		Es comena amb el sistema "totally unconnected" i
%		anem afegint una relacio binaria cada cop. Ens 
%		quedem amb la relacio binaria, dins de cada nivell, 
%		que millor qualitat de reconstruccio del sistema
%		ens dona
%
%	alg = 3 - algorisme de SINGLEREF
%		S'eliminen de cop totes aquelles relacions binaries
%		que permeten tenir un error de reconstruccio per
%		sota del maxim requerit.
%
%
%	fi = 0 - No hi ha fitxer de resultats intermitjos
%
%	fi = 1 - Fer un fitxer de resultats intermitjos
%
%
% 
%	Exemple d'us: 	[csout]=foptstruc(beh,prob,emax,alg,fi)
%
%
%
fid = 0;
%
% Si es vol fitxer, crear-lo i deixar-lo preparat per escriure
%
if ( fi == 1 )
  nom = input('Escriu el nom del fitxer entre comilles simples: ');
  fid = fopen(nom,'wt+');
end;
%
% Segons l'algorisme cridem una funcio diferent
%
if alg == 1 csout = frefine(beh,prob,emax,fid); end;
if alg == 2 csout = faggregate(beh,prob,emax,fid); end;
if alg == 3 csout = fsingleref(beh,prob,emax,fid); end;
%
% Si cal tancar fitxer
%
if fid ~= 0 fclose(fid); end;
%
