function [err] = fstructure(b,p,stri)
%
% Funci que calcula l'error de reconstruir b1 i p1 a partir dels 
% subsistemes que hi ha a stri
%
% Autor: Josep Maria Mirats i Tur
% Data: 5-II-1999, Barcelona
%
% Parmetres:
%
%       Entrada: b, behavior del sistema
%                p, vector de confiances del sistema
%                stri, vector que cont els subsistemes en forma de
%                       composite structure
%
%       Sortida: err, error de reconstrucci del sistema recombinat
%
%       Us de la funci:
%
%                       [err] = fstructure(b,p,stri)
%
%
err = 0;
%
% Comprova que la behavior i el vector de prob. d'entrada sn compatibles
%
a = size(b,1);
c = size(p,1);
if ( a ~= c )
 fprintf('\n FSTRUCTURE. Behavior vector de probabilitats no compatibles \n\n')
 return
end
%
% Troba el nmero de subsistemes
%
index = [0 find(stri == 0) size(stri,2)+1];
n = length(index)-1;
if ( n < 2 )
 fprintf('\n Com a mnim sn necessris dos subsistems \n\n')
 return
end
%
% Extreu el comportament del primer subsistema
%
str1 = stri(index(1)+1:index(2)-1);
[b1,p1] = fextract(b,p,str1);
%
% Bucle que combina i extreu subsistemes fins a completar la reconstrucci
%
for i = 2:n,
 str2 = stri(index(i)+1:index(i+1)-1);
 [b2,p2] = fextract(b,p,str2);
 [b1,p1,str1] = fcombine(b1,p1,b2,p2,[str1 0 str2]);
end
%
% Calcula l'ambigitat del sistema original
%
a1 = calc_amb(p);
%
% Calcula l'ambigitat del sistema reconstuit
%
a2 = calc_amb(p1);
%
% Troba l'error de reconstrucci
%
err = a2-a1;
%
